%{
/* M.Meadele mm@bzero.net Tue May  7 16:17:02 GMT 2002 
 *
 * ---
 * Tue May  7 16:18:11 GMT 2002
 *
 * - first version
 * - radio unimplemented
 * - added method for url
 * - corrected bug with retrieving action value in the form tag
 * - corrected bug with accessing furl when it was not yet malloc()'ed
 * - recorrected bug with accessing furl when it was not yet malloc()'ed
 * ---
 *
 * ---
 * Sat May 11 19:22:49 GMT 2002
 * - moved main() from here to poison.c
 * - corrected a damned bug (bad incrementaion of qn in form retrieval)
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include "url.h"
#include "http.h"
#include "misc.h"
#include "poison.h"
#include "htmlparser.h"

static int yywrap(void);
static void skip_quote(char **, int);

int m = 0;

int hlink    = 0; 
int hform    = 0; 
int qn       = 0;
int p_method = 0;

char *n;
char *v;

struct url_list *ul;
struct s_url    *furl;
%}

SDEL "<"
EDEL ">"

STAG  "<"
ETAG  "</"

SP  " "
TAB \t
RS  \n

WS {SP}|{TAB}|{RS}

L_HREF      ([Hh][Rr][Ee][Ff])
L_FORM      ([Ff][Oo][Rr][Mm])
LF_ACTION   ([Aa][Cc][Tt][Ii][Oo][Nn])
LF_METHOD   ([Mm][Ee][Tt][Hh][Oo][Dd])
LF_INPUT    ([Ii][Nn][Pp][Uu][Tt])
LF_TEXTAREA ([Tt][Ee][Xx][Tt][Aa][Rr][Ee][Aa])
LF_SELECT   ([Ss][Ee][Ll][Ee][Cc][Tt])
LI_NAME     ([Nn][Aa][Mm][Ee])
LI_VAL      ([Vv][Aa][Ll][Uu][Ee])
LS_OPTION   ([Oo][Pp][Tt][Ii][Oo][Nn])
LI_TYPE     ([Tt][Yy][Pp][Ee])

%x H_LINK
%x H_FORM
%x H_SELECT
%x H_SNAM
%x H_TEXT
%x H_TNAM
%x H_OPTION
%x H_SLVAL
%x H_REF
%x H_METHOD
%x H_INPUT
%x H_TYPE
%x H_NAM
%x H_VAL
%x H_PARAM

%%
 /**
  ** extract from <a> tag
  **/
<INITIAL>{SDEL}({WS}*)[aA]({WS}+)([^>]*){L_HREF}"="{WS}*     {
                                                              m = INITIAL;
                                                              BEGIN H_LINK;
                                                              }
<H_INPUT>{SDEL}({WS}*)[aA]({WS}+)([^>]*){L_HREF}"="{WS}*     {
                                                              m = H_INPUT;
                                                              BEGIN H_LINK;
                                                              }
<H_LINK>\"[^"]*\"   |
<H_LINK>[^ ">\n\t]*                                          {
                                                              skip_quote(&yytext, yyleng);
                                                              url_list_stradd(ul, yytext);
                                                              hlink++;
                                                              BEGIN m; 
                                                              }
<H_LINK>{EDEL}                                               {
                                                              BEGIN m;
                                                              }    
 /**
  ** extract from <form> tag
  **/
<INITIAL>{SDEL}({WS}*){L_FORM}({WS}+)                        {
                                                              qn = 0;
                                                              p_method = 0;
                                                              BEGIN H_FORM;
                                                              }
<H_FORM>{LF_METHOD}({WS}*)"="({WS}*)                         {
                                                              BEGIN H_METHOD;
                                                              }
<H_FORM>{LF_ACTION}({WS}*)"="({WS}*)                         {
                                                              BEGIN H_REF;
                                                              }
<H_REF>\"[^"]*\"   |
<H_REF>[^ ">\n\t]*                                           {
                                                              skip_quote(&yytext, yyleng);
                                                              furl = url_build(yytext);
                                                              if( furl == NULL ) { 
                                                                 m_warn("%s", url_strerror(url_errno));
                                                                 BEGIN INITIAL;
                                                                 }
                                                              else {
                                                                 qn += furl->query->sz;
                                                                 if( p_method == M_POST )
                                                                    furl->method = M_POST;
                                                                 else
                                                                    furl->method = M_GET;
                                                                 BEGIN H_FORM;
                                                                 }
                                                              }
<H_METHOD>\"[^"]*\"   |
<H_METHOD>[^ ">\n\t]*                                        {
                                                              skip_quote(&yytext, yyleng);
                                                              if( strcasecmp(yytext, "POST") == 0 )
                                                                 p_method = M_POST;
                                                              else
                                                                 p_method = M_GET;
                                                              BEGIN H_FORM;
                                                              }
<H_REF,H_METHOD>{EDEL}                                       {
                                                              yyless(0);
                                                              BEGIN H_FORM;
                                                              }
<H_FORM>{EDEL}                                               {
                                                              if( furl == NULL )
                                                                 BEGIN INITIAL;
                                                              else
                                                                 BEGIN H_INPUT;
                                                              }
<H_INPUT>{ETAG}({WS}*){L_FORM}({WS}*){EDEL}                  {
                                                              url_list_urladd(ul, furl);
                                                              hform++;
                                                              furl = NULL; /* be sigsegv on error */
                                                              BEGIN INITIAL;
                                                              }
 /**
  ** extract from <textarea> tag (inside <form>)
  **/
<H_INPUT>{SDEL}({WS}*){LF_TEXTAREA}({WS}*)                   {
                                                              n = NULL;
                                                              v = NULL;
                                                              BEGIN H_TEXT;
                                                              }
<H_TEXT>{LI_NAME}({WS}*)"="({WS}*)                           {
                                                              BEGIN H_TNAM;
                                                              }
<H_TNAM>\"[^"]*\"       |
<H_TNAM>[^ ">\t\n]*                                          {
                                                              skip_quote(&yytext, yyleng);
                                                              n = strdup(yytext);
                                                              BEGIN H_TEXT;
                                                              }
<H_TEXT,H_TNAM>{EDEL}   |
<H_TEXT>{ETAG}({WS}*){LF_TEXTAREA}({WS}*){EDEL}              {          
                                                              v = strdup("wpoison");
                                                              url_querypair_add(n, v, qn, furl);
                                                              free(n);
                                                              free(v);
                                                              qn++;
                                                              BEGIN H_INPUT;
                                                              }
 /**
  ** extract from <select> tag (inside <form>)
  **/
<H_INPUT>{SDEL}({WS}*){LF_SELECT}({WS}*)                     {
                                                              n = NULL;
                                                              v = NULL;
                                                              BEGIN H_SELECT;
                                                              }
<H_SELECT>{LI_NAME}({WS}*)"="({WS}*)                         {
                                                              BEGIN H_SNAM;
                                                              }
<H_SNAM>\"[^"]*\"   |
<H_SNAM>[^ ">\t\n]*                                          {
                                                              skip_quote(&yytext, yyleng);
                                                              n = strdup(yytext);
                                                              BEGIN H_SELECT;
                                                              }
<H_SELECT>{SDEL}({WS}*){LS_OPTION}({WS}*)                    { 
                                                              BEGIN H_OPTION;
                                                              }
<H_OPTION>{LI_VAL}({WS}*)"="({WS}*)                          {
                                                              BEGIN H_SLVAL;
                                                              }
<H_SLVAL>\"[^"]*\"          |
<H_SLVAL>[^ ">\t\n]*                                         {
                                                              skip_quote(&yytext, yyleng);
                                                              url_querypair_add(n, yytext, qn, furl);
                                                              free(n);
                                                              qn++;
                                                              /* go away from select */
                                                              BEGIN H_INPUT;
                                                              }
<H_OPTION,H_SLVAL>{EDEL}                                     {
                                                              BEGIN H_SELECT;
                                                              }
<H_SELECT>{ETAG}({WS}*){LF_SELECT}({WS}*){EDEL}              {          
                                                              BEGIN H_INPUT;
                                                              }
 /**
  ** extract from <input> tag (inside <form>)
  **/
<H_INPUT>{SDEL}({WS}*){LF_INPUT}({WS}+)                      {
                                                              n = NULL;
                                                              v = NULL;
                                                              BEGIN H_PARAM;
                                                              }
<H_PARAM>{LI_TYPE}({WS}*)"="({WS}*)                          {
                                                              BEGIN H_TYPE;
                                                              }
<H_TYPE>\"[^"]*\"   |
<H_TYPE>[^ ">\t\n]*                                          {
                                                              skip_quote(&yytext, yyleng);
                                                              if( strcasecmp(yytext, "submit") == 0  ||
                                                                  strcasecmp(yytext, "reset")  == 0  ||
                                                                  strcasecmp(yytext, "button") == 0  ||
                                                                  strcasecmp(yytext, "image")  == 0    )
                                                                 BEGIN H_INPUT; /* skip */
                                                              else
                                                                 BEGIN H_PARAM;
                                                              }
<H_PARAM>{LI_NAME}({WS}*)"="({WS}*)                          {
                                                              BEGIN H_NAM;
                                                              }
<H_PARAM>{LI_VAL}({WS}*)"="({WS}*)                           {
                                                              BEGIN H_VAL;
                                                              }
<H_NAM>\"[^"]*\"   |
<H_NAM>[^ ">\t\n]*                                           {
                                                              skip_quote(&yytext, yyleng);
                                                              n = strdup(yytext);
                                                              BEGIN H_PARAM;
                                                              }
<H_VAL>\"[^"]*\"   |
<H_VAL>[^ ">\t\n]*                                           {
                                                              skip_quote(&yytext, yyleng);
                                                              v = strdup(yytext);
                                                              BEGIN H_PARAM;
                                                              }
<H_PARAM,H_NAM,H_VAL>{EDEL}                                  {
                                                              if( v == NULL )
                                                                 v = strdup("wpoison");
                                                              url_querypair_add(n, v, qn, furl);
                                                              free(n);
                                                              free(v);
                                                              qn++;
                                                              BEGIN H_INPUT;
                                                              }    
<*>.          |
<*>\n             ;
%% 


int yywrap()
{
 
 return 1;
}


void skip_quote(char **s, int sz)
{

 if( **s == '\"' ) {
    (*s)[sz-1] = '\0';
    (*s)++;
    }
 /*
  * why the hell html is so a pain in the ass to parse ?
  */
 else {
    if( **s == '\'' ) {
       (*s)[sz-1] = '\0';
       (*s)++;
       }
    }
}


struct url_list *w_html_parse(char *msg, size_t len)
{
 ul = url_list_alloc();
 yy_scan_buffer(msg, len);

 yylex();

 printf("%d hard links, %d form\n", hlink, hform);

 return ul;
}

