#ifndef _STRESS_H
#define _STRESS_H

#include <regex.h>

#define SIGNATURE_FILE "./poison.sig"

struct key_sig {
   char   *sig;
   regex_t expr;
   struct key_sig *next;
   };

struct w_sign {
   struct key_sig *head;
   struct key_sig *tail;
   int sz;
   };

struct query {
   char *name;
   int   status;
   struct query *next;
   };

struct q_list {
   struct query *head;
   struct query *tail;
   int sz;
   };

struct res {
   char *name;
   int   nvul;
   struct q_list *qlist;
   struct res *next;
   };

struct res_list {
   struct res *head;
   struct res *tail;
   int sz;
   };


void list_init(void);
void list_free(void);
void list_print(void);

int poison_stress_test(struct url_list *, struct w_sign *);

#endif
